Index: lib/marine/marine.xsl
===================================================================
--- lib/marine/marine.xsl	(revision 399)
+++ lib/marine/marine.xsl	(revision 400)
@@ -24,24 +24,21 @@
 	<link rel="stylesheet" type="text/css" href="@html-path@/marine/rowcol.css" />
       </head>
       <body class="emlbody">
-      <script language="JavaScript">
-        function gotoNceas()
-        {
-          window.location="http://www.nceas.ucsb.edu";
-        }
-      </script>
         <a name="top" />
         <table width="100%">
         <tr>
           <td align="left" valign="top">
-            <form action="@html-path@/servlet/marine"
+            <form action="@html-path@/servlet/marine#browse"
                   method="POST">
-               <input type="hidden" name="action" value="query" />   
+             <input type="hidden" name="action" value="query" />   
     	       <input type="hidden" name="query" value="" />
     	       <input type="hidden" name="qformat" value="html" />
-               <input type="hidden" name="operator" value="UNION" />
-               <input type="hidden" name="anyfield" value="%" />
-               <input type="submit" value="Browse the Database" size="15" />
+             <input type="hidden" name="operator" value="UNION" />
+             <input type="hidden" name="anyfield" value="%" />
+             <input type="hidden" name="returnfield" value="title" />
+             <input type="hidden" name="returnfield" value="surname" />
+             <input type="hidden" name="returnfield" value="organizationname" />
+             <input type="submit" value="Browse the Database" size="15" />
             </form>   
           </td>
           <td align="center" valign="bottom">
@@ -49,12 +46,15 @@
                  onClick="gotoNceas()" />
           </td>
           <td align="right" valign="top">
-            <form action="@html-path@/servlet/marine"
+            <form action="@html-path@/servlet/marine#browse"
                   method="POST">
                Quick Search: <input type="text" name="anyfield" size="10" />
                <input type="hidden" name="action" value="query" />   
     	       <input type="hidden" name="qformat" value="html" />
     	       <input type="hidden" name="operator" value="UNION" />
+             <input type="hidden" name="returnfield" value="title" />
+             <input type="hidden" name="returnfield" value="surname" />
+             <input type="hidden" name="returnfield" value="organizationname" />
     	     </form>
     	   </td>
     	 </tr>
@@ -104,7 +104,7 @@
         </p>
         </font>
         
-        <form action="@html-path@/servlet/marine" 
+        <form action="@html-path@/servlet/marine#browse" 
               method="POST"> 
            
         <table width="100%" border="1">
@@ -243,9 +243,16 @@
              </td>
           </tr>
         </table>
-        <input type="hidden" name="action" value="query" />   
+      <input type="hidden" name="action" value="query" />   
     	<input type="hidden" name="qformat" value="html" />
     	<input type="hidden" name="operator" value="UNION" />
+      <!--note that the value of the returnfield can be in either
+         -case but in the xsl:value-of statement the select attribute
+         -must always be in lower case
+       -->
+      <input type="hidden" name="returnfield" value="surname" />
+      <input type="hidden" name="returnfield" value="givenname" />
+      <input type="hidden" name="returnfield" value="organizationname" />
         
         <input type="submit" value="Query" />
         <input type="reset" value="Clear Form" />
@@ -304,26 +311,30 @@
                 </xsl:attribute>
               </input>
           </td>
+          <!--note the lower case select attr. -->
           <td><xsl:value-of select="./doctitle"/>
               
               <xsl:text>&nbsp;</xsl:text>
           </td>
-  <!--        <td><xsl:value-of select="./givenName" />
+          <td>
+              <xsl:value-of select="./givenname" /> 
               <xsl:text>&nbsp;</xsl:text>
-              <xsl:value-of select="./surName" />
+
+              <xsl:value-of select="./surname" />
               <xsl:text>&nbsp;</xsl:text>
           </td>
-          <td><xsl:value-of select="./organizationName" />
+          <td><xsl:value-of select="./organizationname" />
               <xsl:text>&nbsp;</xsl:text>
           </td>
+  
           <td>
-              <xsl:value-of select="./date_created" />
+              <xsl:value-of select="./createdate" />
               <xsl:text>&nbsp;</xsl:text>
           </td>
           <td>
-              <xsl:value-of select="./date_updated" /> 
+              <xsl:value-of select="./updatedate" /> 
               <xsl:text>&nbsp;</xsl:text>
-          </td> -->
+          </td> -
           </tr>
         </xsl:for-each>
         </table>
Index: src/edu/ucsb/nceas/metacat/marine/marineServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/marine/marineServlet.java	(revision 399)
+++ src/edu/ucsb/nceas/metacat/marine/marineServlet.java	(revision 400)
@@ -98,7 +98,6 @@
         query.append("</").append((String)nextkey).append(">");
       }
     }
-    System.out.println(query.toString());
     return query.toString();
   }
 }