Index: lib/marine/marine.xsl
===================================================================
--- lib/marine/marine.xsl	(revision 415)
+++ lib/marine/marine.xsl	(revision 416)
@@ -36,33 +36,41 @@
              <input type="hidden" name="operator" value="UNION" />
              <input type="hidden" name="anyfield" value="%" />
              <input type="hidden" name="returnfield" value="title" />
-             <input type="hidden" name="returnfield" value="surname" />
-             <input type="hidden" name="returnfield" value="organizationname" />
-             <input type="submit" value="Browse the Database" size="15" />
-            </form>   
-          </td>
-          <td align="center" valign="bottom">
-            <img src="@html-path@/marine/logo-line.gif" alt="NCEAS Logo" 
-                 onClick="gotoNceas()" />
-          </td>
-          <td align="right" valign="top">
+             <input type="hidden" name="returnfield" value="surName" />
+             <input type="hidden" name="returnfield" value="organizationName" />
+             <input border="0" type="image" 
+                    src="@image-path@/marine/browsebutton.jpg"
+                    alt="browse the database"
+                    size="15" /><br/>
+             <a href="#beginform" border="0">
+              <img border="0" 
+                   src="@image-path@/marine/skipbutton.jpg" 
+                   alt="skip the introduction"/>
+            </a>
+           </form>
+    	   </td>
+         <td align="center" valign="top">
+            <img src="@image-path@/marine/logo-line.gif" alt="NCEAS Logo" />
+         </td>
+         <td align="right" valign="top">
             <form action="@html-path@/servlet/marine#browse"
                   method="POST">
+               <font size="2">
                Quick Search: <input type="text" name="anyfield" size="10" />
+               </font>
                <input type="hidden" name="action" value="query" />   
     	       <input type="hidden" name="qformat" value="html" />
     	       <input type="hidden" name="operator" value="UNION" />
              <input type="hidden" name="returnfield" value="title" />
-             <input type="hidden" name="returnfield" value="surname" />
-             <input type="hidden" name="returnfield" value="organizationname" />
+             <input type="hidden" name="returnfield" value="surName" />
+             <input type="hidden" name="returnfield" value="organizationName" />
     	     </form>
-    	   </td>
-    	 </tr>
-        </table>
+         </td>
+    	 </tr>  
+       </table>
         
         <hr />
-        
-        <center><h1>MARINE Query Interface</h1></center>
+        <center><h3>MARINE Query Interface</h3></center>
         <font size="2">
         <p class="intro">
           This page is used to query information for 
@@ -103,18 +111,18 @@
            every document).  
         </p>
         </font>
-        
+        <hr />
         <form action="@html-path@/servlet/marine#browse" 
               method="POST"> 
-           
-        <table width="100%" border="1">
+        <a name="beginform" />  
+        <table width="100%" border="0">
           <tr>
              <td valign="bottom" width = "25">
-        	<img src="@html-path@/marine/step1.jpg" />
+        	<img src="@image-path@/marine/step1.jpg" alt="step 1"/>
              </td>
              <td>
-               <h4>Keywords and Title</h4>
                <p>
+               <b><font size="2">Keywords and Title</font></b><br/>
                <font size="2">
                  Enter any keywords that might partain to the dataset you 
                  are looking for.  
@@ -132,37 +140,37 @@
         
         <table width="100%">
              <tr>
-                <td>Title:</td>
+                <td align="right">Title:</td>
                 <td>
-                  <input type="text" name="title" size="15">
+                  <input type="text" name="title" size="30">
                   <xsl:attribute name="value">
                   <xsl:value-of select="resultset/query/title" />
                   </xsl:attribute>
                   </input>
                 </td>
-                <td>Any Field:</td>
-                <td>
-                  <input type="text" name="anyfield" size="15">
-                  <xsl:attribute name="value">
-                  <xsl:value-of select="resultset/query/anyfield" />
+                <td align="right">Alternate Title:</td>
+             	  <td>        
+                <input type="text" name="alttitle" size="30">
+             	  <xsl:attribute name="value">
+                  <xsl:value-of select="resultset/query/alttitle" />
                   </xsl:attribute>
                   </input>
                 </td>
              </tr>
              <tr>
-                <td>Alternate Title:</td>
-             	<td>        
-		  <input type="text" name="alttitle" size="15">
-             	  <xsl:attribute name="value">
-                  <xsl:value-of select="resultset/query/alttitle" />
+              <td align="right">Keywords:</td>
+                <td>
+                  <input type="text" name="keyword" size="30">
+                  <xsl:attribute name="value">
+                  <xsl:value-of select="resultset/query/keyword" />
                   </xsl:attribute>
                   </input>
                 </td>
-                <td>Keywords:</td>
+                <td align="right">Any Field:</td>
                 <td>
-                  <input type="text" name="keyword" size="15">
+                  <input type="text" name="anyfield" size="30">
                   <xsl:attribute name="value">
-                  <xsl:value-of select="resultset/query/keyword" />
+                  <xsl:value-of select="resultset/query/anyfield" />
                   </xsl:attribute>
                   </input>
                 </td>
@@ -169,38 +177,33 @@
              </tr>
         </table>
         
-        <table width="100%" border="1">
+        <table width="100%" border="0">
           <tr>
-             <td valign="bottom" width="25">
-        	<img src="@html-path@/marine/step2.jpg" />
+             <td valign="center" align="left" width="25">
+        	   <img src="@image-path@/marine/step2.jpg" alt="step 2"/>
              </td>
              <td>
-                <h4>Dataset Owner Information</h4>
-        	<p>
-        	   <font size="2">
-        	   Enter data about the owner of the dataset.  There may be more 
-             than one
-        	   owner of any given dataset.  Any field(s) left blank will not be 
-             used
+             <font size="2"><b>Associated Individual Information</b><br/>
+        	   Enter data about an owner or someone else who is associated with
+             the dataset. Any field(s) left blank will not be used
         	   in the search criteria.
         	   </font>
-        	</p>
              </td>
           </tr>
         </table>
         <table width="100%">
              <tr>
-                <td>First Name:</td>
+                <td align="right">First Name:</td>
                 <td> 
-                  <input type="text" name="givenName" size="15">
+                  <input type="text" name="givenName" size="30">
              	  <xsl:attribute name="value">
                   <xsl:value-of select="resultset/query/givenName" />
                   </xsl:attribute>
                   </input>
                 </td>
-                <td>Last Name:</td>
+                <td align="right">Last Name:</td>
                 <td>
-                  <input type="text" name="surName" size="15">
+                  <input type="text" name="surName" size="30">
              	  <xsl:attribute name="value">
                   <xsl:value-of select="resultset/query/surName" />
                   </xsl:attribute>
@@ -208,17 +211,17 @@
                 </td>
              </tr>
              <tr>
-             	<td>Organization:</td>
+             	<td align="right">Organization:</td>
              	<td> 
-             	  <input type="text" name="organizationName" size="15">
+             	  <input type="text" name="organizationName" size="30">
              	  <xsl:attribute name="value">
                   <xsl:value-of select="resultset/query/organizationName" />
                   </xsl:attribute>
                   </input>
                 </td>
-             	<td>Email Address:</td>
+             	<td align="right">Email Address:</td>
              	<td> 
-             	  <input type="text" name="electronicMailAddress" size="15">
+             	  <input type="text" name="electronicMailAddress" size="30">
              	  <xsl:attribute name="value">
                   <xsl:value-of select="resultset/query/electronicMailAddress" />
                   </xsl:attribute>
@@ -226,21 +229,20 @@
                 </td>
              </tr>
            </table>
-           
-        <table width="100%" border="1">
+        <table width="100%" border="0">
           <tr>
-             <td valign="bottom" width="25">
-        	<img src="@html-path@/marine/step3.jpg" />
-             </td>
-             <td>
-        	<h4>Query the Database</h4>
-        	<p>
-        	   <font size="2">
-        	   Click the Query button to submit your query.  The results will be
-        	   displayed below under the heading "Results".
-        	   </font>
-        	</p>
-             </td>
+            <td valign="center" align="left" width="25">
+              <img src="@image-path@/marine/step3.jpg" alt="step 3"/>
+            </td>
+            <td>
+              <p>
+              <b><font size="2">Query the Database</font></b><br/>
+              <font size="2">
+              Click the Query button to submit your query.  The results will be
+              displayed below under the heading "Results".
+              </font>
+              </p>
+            </td>
           </tr>
         </table>
       <input type="hidden" name="action" value="query" />   
@@ -272,11 +274,11 @@
         <table width="100%">
         <tr class="rowodd">
         <th>&nbsp;</th>
-        <th><xsl:text>Title</xsl:text></th>
-        <th><xsl:text>Contacts</xsl:text></th>
-        <th><xsl:text>Organization</xsl:text></th>
-        <th><xsl:text>Creation Date</xsl:text></th>
-        <th><xsl:text>Last Updated</xsl:text></th>
+        <th><font size="2"><xsl:text>Title</xsl:text></font></th>
+        <th><font size="2"><xsl:text>Contacts</xsl:text></font></th>
+        <th><font size="2"><xsl:text>Organization</xsl:text></font></th>
+        <th><font size="2"><xsl:text>Creation Date</xsl:text></font></th>
+        <th><font size="2"><xsl:text>Last Updated</xsl:text></font></th>
         </tr>
 
 	
@@ -296,9 +298,9 @@
                 <xsl:attribute name="src">
                   <xsl:choose>
                     <xsl:when test="position() 
-                         mod 2 = 1">@html-path@/marine/whiteMenu.jpg</xsl:when>
+                         mod 2 = 1">@image-path@/marine/whiteMenu.jpg</xsl:when>
                     <xsl:when test="position() 
-                         mod 2 = 0">@html-path@/marine/blueMenu.jpg</xsl:when>
+                         mod 2 = 0">@image-path@/marine/blueMenu.jpg</xsl:when>
                   </xsl:choose>
                 </xsl:attribute>
                 <xsl:attribute name="name">
@@ -306,27 +308,27 @@
                 </xsl:attribute>
               </input>
           </td>
-          <td><xsl:value-of select="./doctitle"/>
-              
+          <td><font size="2"><xsl:value-of select="./doctitle"/></font>
               <xsl:text>&nbsp;</xsl:text>
           </td>
           <td>
-              <xsl:value-of select="./givenName" /> 
+              <font size="2"><xsl:value-of select="./givenName" /></font> 
               <xsl:text>&nbsp;</xsl:text>
 
-              <xsl:value-of select="./surName" />
+              <font size="2"><xsl:value-of select="./surName" /></font>
               <xsl:text>&nbsp;</xsl:text>
           </td>
-          <td><xsl:value-of select="./organizationName" />
+          <td>
+              <font size="2"><xsl:value-of select="./organizationName" /></font>
               <xsl:text>&nbsp;</xsl:text>
           </td>
   
           <td>
-              <xsl:value-of select="./createdate" />
-              <xsl:text>&nbsp;</xsl:text>
+              <font size="2"><xsl:value-of select="./createdate" /></font>
+              <font size="2"><xsl:text>&nbsp;</xsl:text></font>
           </td>
           <td>
-              <xsl:value-of select="./updatedate" /> 
+              <font size="2"><xsl:value-of select="./updatedate" /></font> 
               <xsl:text>&nbsp;</xsl:text>
           </td>
           </tr>
Index: lib/marine/whiteMenu.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: lib/marine/blueMenu.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: lib/marine/rowcol.css
===================================================================
--- lib/marine/rowcol.css	(revision 415)
+++ lib/marine/rowcol.css	(revision 416)
@@ -2,7 +2,7 @@
  .emlbody    {font-family: Tahoma, sans-serif; background-color:white}
  .rowodd  {background-color: #CCCCCC; color: black; vertical-align: top}
  .roweven {background-color: #F8F8F8; color: black; vertical-align: top}
- .rowlight {background-color: #0099C8; color: black;  vertical-align: top}
+ .rowlight {background-color: #66CCFF; color: black;  vertical-align: top}
  .rowwhite {background-color: #FFFFFF; color: black; vertical-align: top}
  .stephead {background=color: #000000; color: white;}
  .coleven {}
Index: lib/marine/step1.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: lib/marine/step2.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: lib/marine/step3.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream