Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 420)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 421)
@@ -354,7 +354,8 @@
                   throws IOException, SQLException, 
                          ClassNotFoundException, AccessionNumberException {
 
-    String newdocid = AccessionNumber.generate(docid, "DELETE");
+    AccessionNumber ac = new AccessionNumber();
+    String newdocid = ac.generate(docid, "DELETE");
 
     conn.setAutoCommit(false);
     // Copy the record to the xml_revisions table
@@ -375,7 +376,8 @@
       PreparedStatement pstmt = null;
 
       if (action.equals("INSERT")) {
-        this.docid = AccessionNumber.generate(docid, "INSERT");
+        AccessionNumber ac = new AccessionNumber();
+        this.docid = ac.generate(docid, "INSERT");
         pstmt = conn.prepareStatement(
             "INSERT INTO xml_documents " +
             "(docid, rootnodeid, docname, doctype, " +
@@ -389,7 +391,8 @@
       } else if (action.equals("UPDATE")) {
 
         // Determine if the docid is OK for an UPDATE
-        this.docid = AccessionNumber.generate(docid, "UPDATE");
+        AccessionNumber ac = new AccessionNumber();
+        this.docid = ac.generate(docid, "UPDATE");
 
         // Save the old document entry in a backup table
         DocumentImpl.archiveDocRevision( conn, docid );
Index: src/edu/ucsb/nceas/metacat/AccessionNumber.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 420)
+++ src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 421)
@@ -36,7 +36,7 @@
      * When "UPDATE", accession # is required. 
      * When "DELETE", accession # is required. 
      */
-    public static String generate (String accNumber, String action) 
+    public String generate (String accNumber, String action) 
         throws AccessionNumberException, SQLException, ClassNotFoundException
     {
         
@@ -98,7 +98,7 @@
     }    
 
     /** put unique accession # into db connection */
-    private static String put (Connection conn, String globalName, 
+    private String put (Connection conn, String globalName, 
                 String localId, String sep) 
                 throws SQLException
     {
@@ -133,7 +133,7 @@
     }
 
     /** check for existence of Accesssion Number xml_acc_numbers table */
-    private static boolean accNumberUsed(Connection conn, String globalName, 
+    private boolean accNumberUsed(Connection conn, String globalName, 
                 String localId) throws SQLException {
         
       boolean hasAccNumber = false;
@@ -160,7 +160,7 @@
     }    
     
     /** check for existence of Accesssion Number in xml_documents table */
-    private static boolean accNumberIsCurrent(
+    private boolean accNumberIsCurrent(
                 Connection conn, String accNumber) throws SQLException {
         
       boolean hasCurrentAccNumber = false;
@@ -186,7 +186,7 @@
     }    
 
     /** get the last in order local ID by a given global name */
-    private static int get (Connection conn, String globalName) 
+    private int get (Connection conn, String globalName) 
                 throws SQLException
     {
         try {
@@ -214,7 +214,7 @@
 
     
     // get the global part of the accession number
-    private static String getGlobalName (String accNumber, String sep) 
+    private String getGlobalName (String accNumber, String sep) 
         throws StringIndexOutOfBoundsException {
         
         return accNumber.substring(0, accNumber.lastIndexOf(sep));
@@ -221,7 +221,7 @@
     }    
 
     // get the local part of the accession number
-    private static String getLocalId (String accNumber, String sep)
+    private String getLocalId (String accNumber, String sep)
         throws StringIndexOutOfBoundsException {
 
         return accNumber.substring(accNumber.lastIndexOf(sep)+1);
@@ -230,6 +230,10 @@
 
 /**
  * '$Log$
+ * 'Revision 1.11  2000/08/14 20:53:33  jones
+ * 'Added "release" keyword to all metacat source files so that the release
+ * 'number will be evident in software distributions.
+ * '
  * 'Revision 1.10  2000/06/27 04:31:07  jones
  * 'Fixed bugs associated with the new UPDATE and DELETE functions of
  * 'DBWriter.  There were problematic interactions between some static