Index: lib/style/resource.xsl
===================================================================
--- lib/style/resource.xsl	(nonexistent)
+++ lib/style/resource.xsl	(revision 432)
@@ -0,0 +1,127 @@
+<?xml version="1.0"?>
+<!--
+  * marine.xsl
+  *
+  *      Authors: Chad Berkley
+  *    Copyright: 2000 Regents of the University of California and the 
+  *               National Center for Ecological Analysis and Synthesis
+  *  For Details: http://www.nceas.ucsb.edu/
+  *      Created: 2000 July 20
+  *    File Info: '$Id$'  
+  *
+-->
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
+  <xsl:output method="html" />
+  <xsl:template match="/"> 
+    <html>
+    <head>
+      <title>
+        <xsl:value-of select="//title" />
+      </title>
+    </head>
+    <body bgcolor="white">
+      <h1><xsl:value-of select="//title" /></h1>
+      <!-- display the literature specific fields if they are present -->
+      <xsl:if test="count(resource/literature/ISBN) &gt; 0">
+        <h2>ISBN: <xsl:value-of select="resource/literature/ISBN" /></h2>
+      </xsl:if>
+      <xsl:if test="count(resource/literature/editor) &gt; 0">
+        <xsl:for-each select="resource/literature/editor">
+          <h2>editor: <xsl:value-of select="resource/literature/editor" /></h2>
+        </xsl:for-each>
+      </xsl:if>
+      <xsl:if test="count(resource/literature/edition) &gt; 0">
+        <h2>edition: <xsl:value-of select="resource/literature/edition" /></h2>
+      </xsl:if>
+      <xsl:if test="count(resource/literature/volume) &gt; 0">
+        <h2>volume: <xsl:value-of select="resource/literature/volume" /></h2>
+      </xsl:if>
+      <xsl:if test="count(resource/literature/ISBN) &gt; 0">
+        <h2>ISBN: <xsl:value-of select="resource/literature/ISBN" /></h2>
+      </xsl:if>
+      
+      <!-- display the dataset specific field if present -->
+      <xsl:if test="count(resource/dataset/geoForm) &gt; 0">
+        <h2>Data Form: <xsl:value-of select="resource/dataset/geoForm" /></h2>
+      </xsl:if>
+      
+      <!-- display the contact information -->
+      <u><h3>Contacts</h3></u>
+      
+      <xsl:for-each select="resource/*/originator">
+        <xsl:value-of select="./individualName/salutation" />&nbsp;
+        <xsl:value-of select="./individualName/givenName" />&nbsp;
+        <xsl:value-of select="./individualName/surName" />&nbsp;
+        <br />
+        <b><xsl:value-of select="./roleCode" /></b><br/>
+        <xsl:if test="count(resource/*/organizationName) &gt; 0">
+          <xsl:value-of select="./organizationName" />
+          <br />
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/phone/voice) &gt; 0">
+          Voice Number(s):&nbsp;
+          <xsl:for-each select="./contactInfo/phone/voice">
+           <xsl:value-of select="." />
+            <br />
+          </xsl:for-each>
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/phone/facsimile) &gt; 0">
+          Fax Number(s):&nbsp;
+          <xsl:for-each select="./contactInfo/phone/facsimile">
+            <xsl:value-of select="." />
+            <br />
+          </xsl:for-each>
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/phone/other) &gt; 0">
+          Other Number(s):&nbsp;
+          <xsl:for-each select="./contactInfo/phone/other">
+            <xsl:value-of select="." />
+            &nbsp;&nbsp;
+            <xsl:text>Number type:</xsl:text>
+            <xsl:value-of select="/resource/*/*/contactInfo/phone/otherType" />
+            <br />
+          </xsl:for-each>
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/address) &gt; 0">
+          <xsl:value-of select="./contactInfo/address/deliveryPoint" /><br/>
+          <xsl:value-of select="./contactInfo/address/city" />,&nbsp;
+          <xsl:value-of select="./contactInfo/address/administrativeArea" />&nbsp;
+          <xsl:value-of select="./contactInfo/address/postalCode" />&nbsp;<br/>
+          <xsl:value-of select="./contactInfo/address/country" /><br/>
+          <xsl:value-of select="./contactInfo/address/electronicMailAddress" />
+          <br/>
+        </xsl:if>
+          
+        <xsl:if test="count(./onlineResource) &gt; 0">
+          <xsl:value-of select="./onlineResource/linkage/URL" /><br/>
+          <xsl:value-of select="./onlineResource/protocol" /><br/>
+          <xsl:value-of select="./onlineResource/applicationProtocol" /><br/>
+          <xsl:value-of select="./onlineResource/linkage/name" /><br/>
+          <xsl:value-of select="./onlineResource/linkage/description" /><br/>
+          <xsl:value-of select="./onlineResource/linkage/functionCode" /><br/>
+          <br />
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/hoursOfService) &gt; 0">
+          Office hourse: &nbsp;
+          <xsl:value-of select="./contactInfo/hoursOfService" />
+          <br/>
+        </xsl:if>
+        
+        <xsl:if test="count(./contactInfo/contactInstructions) &gt; 0">
+          Contact instructions:&nbsp;
+          <xsl:value-of select="./contactInfo/contactInstructions" />
+          <br/>
+        </xsl:if>
+        
+        <hr />
+      </xsl:for-each>
+      
+    </body>
+    </html>
+  </xsl:template>
+</xsl:stylesheet>

Property changes on: lib/style/resource.xsl
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property